Subject: AW: your mail

From: Hummel Heinrich <[email-masked]>
Date: Wed, 3 Jul 2002 09:07:27 +0200

Find my response next to HH=>
Heinrich

On Tue, Jul 02, 2002 at 04:25:37PM +0200, Hummel Heinrich wrote:
> It  gets weirder  and weirder: The MPLS WG invents a label stack, but does not care at all that any of the
> deeper nested labels may ever be signalled/carried by means of a Label-TLV/object (no public comments to my
> Hierarchical LSPs, draft-hummel-mpls-hierarchical-lsp-01.txt).
> 
> However it is ok, to "steal" the deepest nested label and call it "VC-label" for indexing
> some VRF at some remote PE. 

This is not theft; it's using the labels as they were designed.  How
is using the bottommost label as a VC-labe/VPN label/whatever
"stealing"?  You seem to be attacking the very idea of label stacking,
which is a pretty useful concept.

HH=>I am not against the VC-label and I am appreciating the label stack concept more than anybody else.
But I cannot understand the absence of interest for concatenations of LSPs i.e. for Hierarchical LSPs while at the same
time hash functionality, remote VRF access and maybe Captain-of-the-night news may be put into the labels.
I am pretty confident that whatever MPLS is believed today, as to do better than IP, can be reversed. It only takes
some smarter algorithm than the old-fashioned SPF and state-less IP forwarding would outperform all MPLS TE.

However, the biggest advantage of the label stack cannot be matched by what so ever:
Say you have N=10,000. It means N**2 = 100,000,000.
100,000,000 = 100 * 100 * 100 * 100. Each of the four "100" can easily be put into a 20-bit sized Label.
Four labels can easily be put into one label stack. 4*100 =400 is ridiculously small compared with 100,1000,000.
I admit this is fairly coarse (see more text in my drafts),

IMHO, to extent MPLS signalling protocols (and also M-BGP) as to crack this n-square problem would be a much more ambitious goal.

> Furthermore it is ok, to "steal" the very same label for hashing.
> 

What about IP router vendors that do load-balancing based on L4/L5
information like protocol type and port numbers?  Is that stealing?

Why do we do layering at all ?!! Is it a special smartness to outwit all the rules?

eric

> Independent from what is clean and what is quick&dirty, I cannot detect any sense in giving a hash-meaning to the bottom label at all.
> 
> 
> 
> Heinrich Hummel
> Siemens
> 
> -----Ursprüngliche Nachricht-----
> Von: Eric Rosen [mailto:[email-masked]]
> Gesendet: Dienstag, 2. Juli 2002 16:06
> An: Shahram Davari
> Cc: 'Eric Osborne'; George Sheng; [email-masked]; [email-masked]
> Betreff: Re: your mail 
> 
> 
> Shahram> To do ECMP, you need to  assign hashed values to egress ports. This
> Shahram> assignment is the hash state that I said you need.  
> 
> A hash is  a function that maps  some sequence of octets into  a sequence of
> integers.  If you want to split  traffic over six paths, while ensuring that
> all packets  with the  same bottom label  travel the  same path, you  need a
> function that maps  a 20 bit quantity  into a number from 1-6.   There is no
> need to maintain state of any kind.